searchNodes=[{"doc":"Signet is a library for interacting with private keys, signatures, and Etheruem.","ref":"Signet.html","title":"Signet","type":"module"},{"doc":"","ref":"Signet.html#t:address/0","title":"Signet.address/0","type":"type"},{"doc":"","ref":"Signet.html#t:bytes32/0","title":"Signet.bytes32/0","type":"type"},{"doc":"","ref":"Signet.html#t:signature/0","title":"Signet.signature/0","type":"type"},{"doc":"","ref":"Signet.Filter.html","title":"Signet.Filter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Signet.Filter.html#child_spec/1","title":"Signet.Filter.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Signet.Filter.html#init/1","title":"Signet.Filter.init/1","type":"function"},{"doc":"","ref":"Signet.Filter.html#listen/1","title":"Signet.Filter.listen/1","type":"function"},{"doc":"","ref":"Signet.Filter.html#start_link/1","title":"Signet.Filter.start_link/1","type":"function"},{"doc":"","ref":"Signet.Hash.html","title":"Signet.Hash","type":"module"},{"doc":"Returns the keccak of the given binary message. Examples iex&gt; Signet.Hash.keccak(&quot;test&quot;) &lt;&lt;156, 34, 255, 95, 33, 240, 184, 27, 17, 62, 99, 247, 219, 109, 169, 79, 237, 239, 17, 178, 17, 155, 64, 136, 184, 150, 100, 251, 154, 60, 182, 88&gt;&gt;","ref":"Signet.Hash.html#keccak/1","title":"Signet.Hash.keccak/1","type":"function"},{"doc":"Returns the keccak of the given binary message, as an unsigned. Examples iex&gt; Signet.Hash.keccak_unsigned(&quot;test&quot;) 70622639689279718371527342103894932928233838121221666359043189029713682937432","ref":"Signet.Hash.html#keccak_unsigned/1","title":"Signet.Hash.keccak_unsigned/1","type":"function"},{"doc":"Excessively simple RPC client for Ethereum.","ref":"Signet.RPC.html","title":"Signet.RPC","type":"module"},{"doc":"RPC call to call a transaction and preview results. Examples iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) iex&gt; |&gt; Signet.RPC . call_trx ( ) { :ok , &lt;&lt; 0x0c &gt;&gt; } iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 10 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) iex&gt; |&gt; Signet.RPC . call_trx ( ) { :error , &quot;error 3: execution reverted (0x3d738b2e)&quot; } iex&gt; errors = [ &quot;Unauthorized()&quot; , &quot;BadNonce()&quot; , &quot;NotEnoughSigners()&quot; , &quot;NotActiveWithdrawalAddress()&quot; , &quot;NotActiveOperator()&quot; , &quot;DuplicateSigners()&quot; ] iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 10 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) iex&gt; |&gt; Signet.RPC . call_trx ( errors : errors ) { :error , &quot;error 3: execution reverted (NotActiveOperator()[])&quot; } iex&gt; errors = [ &quot;Cool(uint256,string)&quot; ] iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 11 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) iex&gt; |&gt; Signet.RPC . call_trx ( errors : errors ) { :error , &quot;error 3: execution reverted (Cool(uint256,string)[1, \\&quot; cat \\&quot; ])&quot; }","ref":"Signet.RPC.html#call_trx/2","title":"Signet.RPC.call_trx/2","type":"function"},{"doc":"RPC call to call to estimate gas used by a given call. Examples iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) iex&gt; |&gt; Signet.RPC . estimate_gas ( ) { :ok , 0x0d }","ref":"Signet.RPC.html#estimate_gas/2","title":"Signet.RPC.estimate_gas/2","type":"function"},{"doc":"Helper function to work with other Signet modules to get a nonce, sign a transction, and transmit it to the network. If you need higher-level functionality, like manual nonce tracking, you may want to use the more granular function calls. Options: gas_price - Set the gas price for the transaction (default {1, :gwei} ) gas_limit - Set the gas limit for the transaction (default: calls eth_estimateGas ) gas_buffer - Buffer if estimating gas limit (default: 1.5 = 150%) value - Value to provide with transaction in wei (default: 0) nonce - Nonce to send with transaction. (default: lookup via eth_transactionCount ) verify - Verify the function is likely to succeed before submitting (default: true) Note: if we don't verify , then estimateGas will likely fail if the transaction were to fail. To prevent this , ` gas_limit ` should always be supplied when ` verify ` is set to false . Examples iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , trx_id } = Signet.RPC . execute_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , { &quot;baz(uint,address)&quot; , [ 50 , :binary . decode_unsigned ( &lt;&lt; 1 :: 160 &gt;&gt; ) ] } , gas_price : { 50 , :gwei } , value : 0 , signer : signer_proc ) iex&gt; &lt;&lt; nonce :: integer - size ( 8 ) , gas_price :: integer - size ( 64 ) , gas_limit :: integer - size ( 24 ) , to :: binary &gt;&gt; = trx_id iex&gt; { nonce , gas_price , gas_limit , to } { 4 , 50000000000 , 20 , &lt;&lt; 1 :: 160 &gt;&gt; } iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , trx_id } = Signet.RPC . execute_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , { &quot;baz(uint,address)&quot; , [ 50 , &lt;&lt; 1 :: 160 &gt;&gt; |&gt; :binary . decode_unsigned ] } , gas_price : { 50 , :gwei } , gas_limit : 100_000 , value : 0 , signer : signer_proc ) iex&gt; &lt;&lt; nonce :: integer - size ( 8 ) , gas_price :: integer - size ( 64 ) , gas_limit :: integer - size ( 24 ) , to :: binary &gt;&gt; = trx_id iex&gt; { nonce , gas_price , gas_limit , to } { 4 , 50000000000 , 100000 , &lt;&lt; 1 :: 160 &gt;&gt; } iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , trx_id } = Signet.RPC . execute_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , { &quot;baz(uint,address)&quot; , [ 50 , &lt;&lt; 1 :: 160 &gt;&gt; |&gt; :binary . decode_unsigned ] } , gas_price : { 50 , :gwei } , gas_limit : 100_000 , value : 0 , nonce : 10 , signer : signer_proc ) iex&gt; &lt;&lt; nonce :: integer - size ( 8 ) , gas_price :: integer - size ( 64 ) , gas_limit :: integer - size ( 24 ) , to :: binary &gt;&gt; = trx_id iex&gt; { nonce , gas_price , gas_limit , to } { 10 , 50000000000 , 100000 , &lt;&lt; 1 :: 160 &gt;&gt; } iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; Signet.RPC . execute_trx ( &lt;&lt; 10 :: 160 &gt;&gt; , { &quot;baz(uint,address)&quot; , [ 50 , &lt;&lt; 1 :: 160 &gt;&gt; |&gt; :binary . decode_unsigned ] } , gas_price : { 50 , :gwei } , gas_limit : 100_000 , value : 0 , nonce : 10 , signer : signer_proc ) { :error , &quot;error 3: execution reverted (0x3d738b2e)&quot; } iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , trx_id } = Signet.RPC . execute_trx ( &lt;&lt; 10 :: 160 &gt;&gt; , { &quot;baz(uint,address)&quot; , [ 50 , &lt;&lt; 1 :: 160 &gt;&gt; |&gt; :binary . decode_unsigned ] } , gas_price : { 50 , :gwei } , gas_limit : 100_000 , value : 0 , nonce : 10 , verify : false , signer : signer_proc ) iex&gt; &lt;&lt; nonce :: integer - size ( 8 ) , gas_price :: integer - size ( 64 ) , gas_limit :: integer - size ( 24 ) , to :: binary &gt;&gt; = trx_id iex&gt; { nonce , gas_price , gas_limit , to } { 10 , 50000000000 , 100000 , &lt;&lt; 10 :: 160 &gt;&gt; }","ref":"Signet.RPC.html#execute_trx/3","title":"Signet.RPC.execute_trx/3","type":"function"},{"doc":"RPC call to get account nonce. Examples iex&gt; Signet.RPC . get_nonce ( Signet.Util . decode_hex! ( &quot;0x407d73d8a49eeb85d32cf465507dd71d507100c1&quot; ) ) { :ok , 4 }","ref":"Signet.RPC.html#get_nonce/2","title":"Signet.RPC.get_nonce/2","type":"function"},{"doc":"Simple RPC client for a JSON-RPC Ethereum node. Examples iex&gt; Signet.RPC . send_rpc ( &quot;net_version&quot; , [ ] ) { :ok , &quot;3&quot; } iex&gt; Signet.RPC . send_rpc ( &quot;get_balance&quot; , [ &quot;0x407d73d8a49eeb85d32cf465507dd71d507100c1&quot; , &quot;latest&quot; ] , ethereum_node : &quot;http://example.com&quot; ) { :ok , &quot;0x0234c8a3397aab58&quot; }","ref":"Signet.RPC.html#send_rpc/3","title":"Signet.RPC.send_rpc/3","type":"function"},{"doc":"RPC call to send a raw transaction. Examples iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , signed_trx } = Signet.Transaction . build_signed_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , 5 , { &quot;baz(uint,address)&quot; , [ 50 , :binary . decode_unsigned ( &lt;&lt; 1 :: 160 &gt;&gt; ) ] } , { 50 , :gwei } , 100_000 , 0 , chain_id : :goerli , signer : signer_proc ) iex&gt; { :ok , trx_id } = Signet.RPC . send_trx ( signed_trx ) iex&gt; &lt;&lt; nonce :: integer - size ( 8 ) , gas_price :: integer - size ( 64 ) , gas_limit :: integer - size ( 24 ) , to :: binary &gt;&gt; = trx_id iex&gt; { nonce , gas_price , gas_limit , to } { 5 , 50000000000 , 100000 , &lt;&lt; 1 :: 160 &gt;&gt; }","ref":"Signet.RPC.html#send_trx/2","title":"Signet.RPC.send_trx/2","type":"function"},{"doc":"","ref":"Signet.Recover.html","title":"Signet.Recover","type":"module"},{"doc":"Finds the given recid which recovers the given signature for the message to the given Ethereum address. This is a very simple guess-check-revise since there are only four possible values, and we only accept two of those. Examples iex&gt; priv_key = Base.decode16!(&quot;800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf&quot;, case: :mixed) iex&gt; {:ok, sig} = Signet.Signer.Curvy.sign(&quot;test&quot;, priv_key) iex&gt; {:ok, recid} = Signet.Recover.find_recid(&quot;test&quot;, sig, Base.decode16!(&quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;)) iex&gt; Signet.Recover.recover_eth(&quot;test&quot;, %{sig|recid: recid}) |&gt; Base.encode16() &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Recover.html#find_recid/3","title":"Signet.Recover.find_recid/3","type":"function"},{"doc":<<80, 114, 101, 102, 105, 120, 101, 115, 32, 97, 32, 109, 101, 115, 115, 97, 103, 101, 32, 119, 105, 116, 104, 32, 38, 113, 117, 111, 116, 59, 69, 116, 104, 101, 114, 117, 101, 109, 32, 83, 105, 103, 110, 101, 100, 32, 77, 101, 115, 115, ...>>,"ref":"Signet.Recover.html#prefix_eth/1","title":"Signet.Recover.prefix_eth/1","type":"function"},{"doc":"Recovers a signer's Ethereum address from a signed message. The message will be digested by keccak first. Note: the rec_id can be embeded in the signature or passed separately. Examples iex&gt; priv_key = Base.decode16!(&quot;800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf&quot;, case: :mixed) iex&gt; {:ok, sig} = Signet.Signer.Curvy.sign(&quot;test&quot;, priv_key) iex&gt; {:ok, recid} = Signet.Recover.find_recid(&quot;test&quot;, sig, Base.decode16!(&quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;)) iex&gt; Signet.Recover.recover_eth(&quot;test&quot;, %{sig|recid: recid}) |&gt; Base.encode16() &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Recover.html#recover_eth/2","title":"Signet.Recover.recover_eth/2","type":"function"},{"doc":"Recovers a signer's public key from a signed message. The message will be digested by keccak first. Note: the rec_id can be embeded in the signature or passed separately. Examples iex&gt; priv_key = Base.decode16!(&quot;800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf&quot;, case: :mixed) iex&gt; {:ok, sig} = Signet.Signer.Curvy.sign(&quot;test&quot;, priv_key) iex&gt; {:ok, recid} = Signet.Recover.find_recid(&quot;test&quot;, sig, Base.decode16!(&quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;)) iex&gt; Signet.Recover.recover_public_key(&quot;test&quot;, %{sig|recid: recid}) |&gt; Base.encode16() &quot;0480076BFB96955526052B2676DFCA87E0B7869CE85E00C5DBCE29E76B8429D6DBF0F33B1A0095B2A9A4D9EA2A9746B122995A5B5874EE3161138C9D19F072B2D9&quot;","ref":"Signet.Recover.html#recover_public_key/2","title":"Signet.Recover.recover_public_key/2","type":"function"},{"doc":"","ref":"Signet.Signer.html","title":"Signet.Signer","type":"module"},{"doc":"Gets the address for this signer. Examples iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; Signet.Signer . address ( signer_proc ) |&gt; Base . encode16 ( ) &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Signer.html#address/1","title":"Signet.Signer.address/1","type":"function"},{"doc":"Gets the chain id for this signer. Examples iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; Signet.Signer . chain_id ( signer_proc ) 5","ref":"Signet.Signer.html#chain_id/1","title":"Signet.Signer.chain_id/1","type":"function"},{"doc":"Signet.Signer is a GenServer which can sign messages. This module takes an mfa (mod, func, args triple) which defines how to actually sign messages. For instance, Signet.Signer.Curvy will sign with a public key, or Signet.Signer.CloudKMS will sign using a GCP Cloud KMS key. In either case, the caller should start the GenServer, and then call: Signet.Signer.sign(MySigner, &quot;message&quot;) . This should return back a properly signed message. Note: we also enforce that a given signer process knows its public key, such that we can verify signatures recovery bits. That is, since CloudKMS and other signing tools don't return a recovery bit, necessary for Ethereum, we test all 4 possible bits to make sure a signature recovers to the correct signer address, but we need to know what that address should be to accomplish this task. Additionally, chain_id is used to return EIP-155 compliant signatures.","ref":"Signet.Signer.html#child_spec/1","title":"Signet.Signer.child_spec/1","type":"function"},{"doc":"Handles signing a message.","ref":"Signet.Signer.html#handle_call/3","title":"Signet.Signer.handle_call/3","type":"function"},{"doc":"Tracks the address for determining the recovery bit. We do not permit signatures until this address is known.","ref":"Signet.Signer.html#handle_cast/2","title":"Signet.Signer.handle_cast/2","type":"function"},{"doc":"Tracks the address for determining the recovery bit. We do not permit signatures until this address is known.","ref":"Signet.Signer.html#handle_info/2","title":"Signet.Signer.handle_info/2","type":"function"},{"doc":"Initializes a new Signet.Signer. We make sure to assign set_address , but we send a message to perform that action, largely so that other processes have a chance to start before this does. This is important for Goth keys to access Cloud KMS.","ref":"Signet.Signer.html#init/1","title":"Signet.Signer.init/1","type":"function"},{"doc":"Signs a message using this signing key. Examples iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , sig } = Signet.Signer . sign ( &quot;test&quot; , signer_proc ) iex&gt; Signet.Recover . recover_eth ( &quot;test&quot; , sig ) |&gt; Base . encode16 ( ) &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Signer.html#sign/2","title":"Signet.Signer.sign/2","type":"function"},{"doc":"Directly sign a message, not using a signer process. This is mostly used internally, but can be used safely externally as well.","ref":"Signet.Signer.html#sign_direct/4","title":"Signet.Signer.sign_direct/4","type":"function"},{"doc":"Starts a new Signet.Signer process.","ref":"Signet.Signer.html#start_link/1","title":"Signet.Signer.start_link/1","type":"function"},{"doc":"Signer to sign messages from a Google Cloud KMS key.","ref":"Signet.Signer.CloudKMS.html","title":"Signet.Signer.CloudKMS","type":"module"},{"doc":"Get the Ethereum address associated with the given KMS key version. Examples iex&gt; { :ok , address } = Signet.Signer.CloudKMS . get_address ( &quot;token&quot; , &quot;project&quot; , &quot;location&quot; , &quot;keychain&quot; , &quot;key&quot; , &quot;version&quot; ) iex&gt; Base . encode16 ( address ) &quot;DDA641B2A76A4A7C3617815BB13281DD207B74D5&quot;","ref":"Signet.Signer.CloudKMS.html#get_address/6","title":"Signet.Signer.CloudKMS.get_address/6","type":"function"},{"doc":"Signs a message with the given KMS key version, after digesting the message with keccak. Examples iex&gt; { :ok , sig } = Signet.Signer.CloudKMS . sign ( &quot;test&quot; , &quot;token&quot; , &quot;project&quot; , &quot;location&quot; , &quot;keychain&quot; , &quot;key&quot; , &quot;version&quot; ) iex&gt; { :ok , recid } = Signet.Recover . find_recid ( &quot;test&quot; , sig , Base . decode16! ( &quot;DDA641B2A76A4A7C3617815BB13281DD207B74D5&quot; ) ) iex&gt; Signet.Recover . recover_eth ( &quot;test&quot; , %{ sig | recid : recid } ) |&gt; Base . encode16 ( ) &quot;DDA641B2A76A4A7C3617815BB13281DD207B74D5&quot;","ref":"Signet.Signer.CloudKMS.html#sign/7","title":"Signet.Signer.CloudKMS.sign/7","type":"function"},{"doc":"Signer to sign messages using a private key directly. Note: this should not be used in production systems. Please see Signet.Signer.CloudKMS .","ref":"Signet.Signer.Curvy.html","title":"Signet.Signer.Curvy","type":"module"},{"doc":"Get the Ethereum address associated with the given private key. Examples iex&gt; priv_key = &quot;800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf&quot; |&gt; Base . decode16! ( case : :mixed ) iex&gt; { :ok , address } = Signet.Signer.Curvy . get_address ( priv_key ) iex&gt; Base . encode16 ( address ) &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Signer.Curvy.html#get_address/1","title":"Signet.Signer.Curvy.get_address/1","type":"function"},{"doc":"Signs the given message using the private key, after digesting the message with keccak. Examples iex&gt; priv_key = Base . decode16! ( &quot;800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf&quot; , case : :mixed ) iex&gt; { :ok , sig } = Signet.Signer.Curvy . sign ( &quot;test&quot; , priv_key ) iex&gt; { :ok , recid } = Signet.Recover . find_recid ( &quot;test&quot; , sig , Base . decode16! ( &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot; ) ) iex&gt; Signet.Recover . recover_eth ( &quot;test&quot; , %{ sig | recid : recid } ) |&gt; Base . encode16 ( ) &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Signer.Curvy.html#sign/2","title":"Signet.Signer.Curvy.sign/2","type":"function"},{"doc":"A module for helping tests by providing responses without needing to connect to a real Etheruem node.","ref":"Signet.Test.Client.html","title":"Signet.Test.Client","type":"module"},{"doc":"","ref":"Signet.Test.Client.html#eth_call/2","title":"Signet.Test.Client.eth_call/2","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#eth_estimateGas/2","title":"Signet.Test.Client.eth_estimateGas/2","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#eth_getFilterChanges/1","title":"Signet.Test.Client.eth_getFilterChanges/1","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#eth_getTransactionCount/2","title":"Signet.Test.Client.eth_getTransactionCount/2","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#eth_newFilter/1","title":"Signet.Test.Client.eth_newFilter/1","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#eth_sendRawTransaction/1","title":"Signet.Test.Client.eth_sendRawTransaction/1","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#get_balance/2","title":"Signet.Test.Client.get_balance/2","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#net_version/0","title":"Signet.Test.Client.net_version/0","type":"function"},{"doc":"","ref":"Signet.Test.Client.html#post/3","title":"Signet.Test.Client.post/3","type":"function"},{"doc":"A module to help with testing by setting up a simple signer with a unique name, to prevent name overlap in tests.","ref":"Signet.Test.Signer.html","title":"Signet.Test.Signer","type":"module"},{"doc":"","ref":"Signet.Test.Signer.html#start_signer/1","title":"Signet.Test.Signer.start_signer/1","type":"function"},{"doc":"A module to help build, sign and encode Ethereum transactions.","ref":"Signet.Transaction.html","title":"Signet.Transaction","type":"module"},{"doc":"Builds and signs a transaction, to be ready to be passed to JSON-RPC. Optionally takes a callback to modify the transaction before it is signed. Examples iex&gt; signer_proc = Signet.Test.Signer . start_signer ( ) iex&gt; { :ok , signed_trx } = Signet.Transaction . build_signed_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , 5 , { &quot;baz(uint,address)&quot; , [ 50 , :binary . decode_unsigned ( &lt;&lt; 1 :: 160 &gt;&gt; ) ] } , { 50 , :gwei } , 100_000 , 0 , signer : signer_proc , chain_id : :goerli ) iex&gt; { :ok , signer } = Signet.Transaction.V1 . recover_signer ( signed_trx , 5 ) iex&gt; Base . encode16 ( signer ) &quot;63CC7C25E0CDB121ABB0FE477A6B9901889F99A7&quot;","ref":"Signet.Transaction.html#build_signed_trx/7","title":"Signet.Transaction.build_signed_trx/7","type":"function"},{"doc":"Builds a v1-style call to a given contract Examples iex&gt; Signet.Transaction . build_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , 5 , { &quot;baz(uint,address)&quot; , [ 50 , :binary . decode_unsigned ( &lt;&lt; 1 :: 160 &gt;&gt; ) ] } , { 50 , :gwei } , 100_000 , 0 , 5 ) % Signet.Transaction.V1 { nonce : 5 , gas_price : 50000000000 , gas_limit : 100000 , to : &lt;&lt; 1 :: 160 &gt;&gt; , value : 0 , data : Base . decode16! ( &quot;A291ADD600000000000000000000000000000000000000000000000000000000000000320000000000000000000000000000000000000000000000000000000000000001&quot; ) , v : 5 , r : 0 , s : 0 } iex&gt; call_data = Base . decode16! ( &quot;A291ADD600000000000000000000000000000000000000000000000000000000000000320000000000000000000000000000000000000000000000000000000000000001&quot; ) ...&gt; Signet.Transaction . build_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , 5 , call_data , { 50 , :gwei } , 100_000 , 0 , 5 ) % Signet.Transaction.V1 { nonce : 5 , gas_price : 50000000000 , gas_limit : 100000 , to : &lt;&lt; 1 :: 160 &gt;&gt; , value : 0 , data : Base . decode16! ( &quot;A291ADD600000000000000000000000000000000000000000000000000000000000000320000000000000000000000000000000000000000000000000000000000000001&quot; ) , v : 5 , r : 0 , s : 0 }","ref":"Signet.Transaction.html#build_trx/7","title":"Signet.Transaction.build_trx/7","type":"function"},{"doc":"Represents a V1 or &quot;Legacy&quot; (that is, pre-EIP-1559) transaction.","ref":"Signet.Transaction.V1.html","title":"Signet.Transaction.V1","type":"module"},{"doc":"Adds a signature to a transaction. This overwrites the [chain_id, 0, 0] fields, as per EIP-155. Examples iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) ...&gt; |&gt; Signet.Transaction.V1 . add_signature ( &lt;&lt; 1 :: 256 , 2 :: 256 , 3 :: 8 &gt;&gt; ) % Signet.Transaction.V1 { nonce : 1 , gas_price : 100000000000 , gas_limit : 100000 , to : &lt;&lt; 1 :: 160 &gt;&gt; , value : 2 , data : &lt;&lt; 1 , 2 , 3 &gt;&gt; , v : 3 , r : &lt;&lt; 1 :: 256 &gt;&gt; , s : &lt;&lt; 2 :: 256 &gt;&gt; }","ref":"Signet.Transaction.V1.html#add_signature/2","title":"Signet.Transaction.V1.add_signature/2","type":"function"},{"doc":"Decode an RLP-encoded transaction. Examples iex&gt; &quot;E80185174876E800830186A094000000000000000000000000000000000000000102830102032A8080&quot; ...&gt; |&gt; Base . decode16! ( ) ...&gt; |&gt; Signet.Transaction.V1 . decode ( ) { :ok , % Signet.Transaction.V1 { nonce : 1 , gas_price : 100000000000 , gas_limit : 100000 , to : &lt;&lt; 1 :: 160 &gt;&gt; , value : 2 , data : &lt;&lt; 1 , 2 , 3 &gt;&gt; , v : 42 , r : 0 , s : 0 } }","ref":"Signet.Transaction.V1.html#decode/1","title":"Signet.Transaction.V1.decode/1","type":"function"},{"doc":"Build an RLP-encoded transaction. Note: transactions can be encoded before they are signed, which uses [chain_id, 0, 0] in the signature fields, otherwise those fields are [v, r, s] . Examples iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) ...&gt; |&gt; Signet.Transaction.V1 . encode ( ) ...&gt; |&gt; Base . encode16 ( ) &quot;E80185174876E800830186A094000000000000000000000000000000000000000102830102032A8080&quot;","ref":"Signet.Transaction.V1.html#encode/1","title":"Signet.Transaction.V1.encode/1","type":"function"},{"doc":"Recovers a signature from a transaction, if it's been signed. Otherwise returns an error. Examples iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) ...&gt; |&gt; Signet.Transaction.V1 . add_signature ( &lt;&lt; 1 :: 256 , 2 :: 256 , 3 :: 8 &gt;&gt; ) ...&gt; |&gt; Signet.Transaction.V1 . get_signature ( ) { :ok , &lt;&lt; 1 :: 256 , 2 :: 256 , 3 :: 8 &gt;&gt; } iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) ...&gt; |&gt; Signet.Transaction.V1 . get_signature ( ) { :error , &quot;transaction missing signature&quot; }","ref":"Signet.Transaction.V1.html#get_signature/1","title":"Signet.Transaction.V1.get_signature/1","type":"function"},{"doc":"Constructs a new V1 (Legacy) Ethereum transaction. Examples iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) % Signet.Transaction.V1 { nonce : 1 , gas_price : 100000000000 , gas_limit : 100000 , to : &lt;&lt; 1 :: 160 &gt;&gt; , value : 2 , data : &lt;&lt; 1 , 2 , 3 &gt;&gt; , v : 42 , r : 0 , s : 0 }","ref":"Signet.Transaction.V1.html#new/7","title":"Signet.Transaction.V1.new/7","type":"function"},{"doc":"Recovers the signer from a given transaction, if it's been signed. Examples iex&gt; { :ok , address } = ...&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) ...&gt; |&gt; Signet.Transaction.V1 . add_signature ( &lt;&lt; 1 :: 256 , 2 :: 256 , 3 :: 8 &gt;&gt; ) ...&gt; |&gt; Signet.Transaction.V1 . recover_signer ( :kovan ) ...&gt; Base . encode16 ( address ) &quot;47643AC1194D7E8C6D04DD631D456137028BBC1F&quot; iex&gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; , :kovan ) ...&gt; |&gt; Signet.Transaction.V1 . recover_signer ( :kovan ) { :error , &quot;transaction missing signature&quot; }","ref":"Signet.Transaction.V1.html#recover_signer/2","title":"Signet.Transaction.V1.recover_signer/2","type":"function"},{"doc":"Module to build EIP-712 typed data, which can then be signed or recovered from.","ref":"Signet.Typed.html","title":"Signet.Typed","type":"module"},{"doc":"Deserializes a Typed value from JSON or a map into a struct. Examples iex&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Ether Mail&quot; , ...&gt; &quot;version&quot; =&gt; &quot;1&quot; , ...&gt; &quot;chainId&quot; =&gt; 1 , ...&gt; &quot;verifyingContract&quot; =&gt; &quot;0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC&quot; ...&gt; } , ...&gt; &quot;types&quot; =&gt; %{ ...&gt; &quot;Person&quot; =&gt; [ ...&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;name&quot; , ...&gt; &quot;type&quot; =&gt; &quot;string&quot; ...&gt; } , ...&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;wallet&quot; , ...&gt; &quot;type&quot; =&gt; &quot;address&quot; ...&gt; } , ...&gt; ] , ...&gt; &quot;Mail&quot; =&gt; [ ...&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;from&quot; , ...&gt; &quot;type&quot; =&gt; &quot;Person&quot; ...&gt; } , ...&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;to&quot; , ...&gt; &quot;type&quot; =&gt; &quot;Person&quot; ...&gt; } , ...&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;contents&quot; , ...&gt; &quot;type&quot; =&gt; &quot;string&quot; ...&gt; } , ...&gt; ] ...&gt; } , ...&gt; &quot;value&quot; =&gt; %{ ...&gt; &quot;from&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Cow&quot; , &quot;wallet&quot; =&gt; &quot;0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826&quot; } , ...&gt; &quot;to&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Bob&quot; , &quot;wallet&quot; =&gt; &quot;0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB&quot; } , ...&gt; &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; ...&gt; } ...&gt; } ...&gt; |&gt; Signet.Typed . deserialize ( ) % Signet.Typed { domain : % Signet.Typed.Domain { chain_id : 1 , name : &quot;Ether Mail&quot; , verifying_contract : &quot; \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC&quot; , version : &quot;1&quot; } , types : %{ &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } } , value : %{ &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; , &quot;from&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Cow&quot; , &quot;wallet&quot; =&gt; &lt;&lt; 205 , 42 , 61 , 159 , 147 , 142 , 19 , 205 , 148 , 126 , 192 , 90 , 188 , 127 , 231 , 52 , 223 , 141 , 216 , 38 &gt;&gt; } , &quot;to&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Bob&quot; , &quot;wallet&quot; =&gt; &lt;&lt; 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 &gt;&gt; } } }","ref":"Signet.Typed.html#deserialize/1","title":"Signet.Typed.deserialize/1","type":"function"},{"doc":"Builds a domain struct for a given type, per the EIP-712 spec. Examples iex&gt; % Signet.Typed { ...&gt; domain : % Signet.Typed.Domain { ...&gt; chain_id : 1 , ...&gt; name : &quot;Ether Mail&quot; , ...&gt; verifying_contract : Signet.Util . decode_hex! ( &quot;0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC&quot; ) , ...&gt; version : &quot;1&quot; ...&gt; } , ...&gt; types : %{ ...&gt; &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , ...&gt; &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } ...&gt; } , ...&gt; value : %{ ...&gt; &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; , ...&gt; &quot;from&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Cow&quot; , ...&gt; &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826&quot; ) ...&gt; } , ...&gt; &quot;to&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Bob&quot; , ...&gt; &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB&quot; ) ...&gt; } ...&gt; } ...&gt; } ...&gt; |&gt; Signet.Typed . domain_seperator ( ) ...&gt; |&gt; Signet.Util . encode_hex ( ) &quot;0xF2CEE375FA42B42143804025FC449DEAFD50CC031CA257E0B194A650A912090F&quot;","ref":"Signet.Typed.html#domain_seperator/1","title":"Signet.Typed.domain_seperator/1","type":"function"},{"doc":"Encodes a given typed value such that it can be signed or recovered. Examples iex&gt; % Signet.Typed { ...&gt; domain : % Signet.Typed.Domain { ...&gt; chain_id : 1 , ...&gt; name : &quot;Ether Mail&quot; , ...&gt; verifying_contract : Signet.Util . decode_hex! ( &quot;0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC&quot; ) , ...&gt; version : &quot;1&quot; ...&gt; } , ...&gt; types : %{ ...&gt; &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , ...&gt; &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } ...&gt; } , ...&gt; value : %{ ...&gt; &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; , ...&gt; &quot;from&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Cow&quot; , ...&gt; &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826&quot; ) ...&gt; } , ...&gt; &quot;to&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Bob&quot; , ...&gt; &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB&quot; ) ...&gt; } ...&gt; } ...&gt; } ...&gt; |&gt; Signet.Typed . encode ( ) ...&gt; |&gt; Signet.Util . encode_hex ( ) &quot;0x1901F2CEE375FA42B42143804025FC449DEAFD50CC031CA257E0B194A650A912090FC52C0EE5D84264471806290A3F2C4CECFC5490626BF912D01F240D7A274B371E&quot;","ref":"Signet.Typed.html#encode/1","title":"Signet.Typed.encode/1","type":"function"},{"doc":"Encodes the struct type per EIP-712. For this, we basically build an ABI-style value like Mail(Person from,Person to,string contents) , but then to that we need to append any other types we've seen, like: Mail(Person from,Person to,string contents)Person(string name,address wallet) . This is a tail-call optimized implementation to build the types then track and append types that need to be added. Examples iex&gt; Signet.Typed . encode_type ( &quot;Mail&quot; , %{ ...&gt; &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , ...&gt; &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } ...&gt; } ) &quot;Mail(Person from,Person to,string contents)Person(string name,address wallet)&quot;","ref":"Signet.Typed.html#encode_type/2","title":"Signet.Typed.encode_type/2","type":"function"},{"doc":"Hashes a struct value, per the EIP-712 spec. Examples iex&gt; types = %{ ...&gt; &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , ...&gt; &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } ...&gt; } ...&gt; value = %{ ...&gt; &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; , ...&gt; &quot;from&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Cow&quot; , ...&gt; &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826&quot; ) ...&gt; } , ...&gt; &quot;to&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Bob&quot; , ...&gt; &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB&quot; ) ...&gt; } ...&gt; } ...&gt; Signet.Typed . hash_struct ( &quot;Mail&quot; , value , types ) ...&gt; |&gt; Signet.Util . encode_hex ( ) &quot;0xC52C0EE5D84264471806290A3F2C4CECFC5490626BF912D01F240D7A274B371E&quot;","ref":"Signet.Typed.html#hash_struct/3","title":"Signet.Typed.hash_struct/3","type":"function"},{"doc":"Serializes a Typed value, such that it can be passed to JSON or JavaScript. Examples iex&gt; % Signet.Typed { ...&gt; domain : % Signet.Typed.Domain { ...&gt; chain_id : 1 , ...&gt; name : &quot;Ether Mail&quot; , ...&gt; verifying_contract : &quot; \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC \\x CC&quot; , ...&gt; version : &quot;1&quot; ...&gt; } , ...&gt; types : %{ ...&gt; &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , ...&gt; &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } ...&gt; } , ...&gt; value : %{ ...&gt; &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; , ...&gt; &quot;from&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Cow&quot; , ...&gt; &quot;wallet&quot; =&gt; &lt;&lt; 205 , 42 , 61 , 159 , 147 , 142 , 19 , 205 , 148 , 126 , 192 , 90 , 188 , 127 , 231 , 52 , 223 , 141 , 216 , 38 &gt;&gt; ...&gt; } , ...&gt; &quot;to&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Bob&quot; , ...&gt; &quot;wallet&quot; =&gt; ...&gt; &lt;&lt; 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 , 187 &gt;&gt; ...&gt; } ...&gt; } ...&gt; } ...&gt; |&gt; Signet.Typed . serialize ( ) %{ &quot;domain&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Ether Mail&quot; , &quot;version&quot; =&gt; &quot;1&quot; , &quot;chainId&quot; =&gt; 1 , &quot;verifyingContract&quot; =&gt; &quot;0xCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC&quot; } , &quot;types&quot; =&gt; %{ &quot;Person&quot; =&gt; [ %{ &quot;name&quot; =&gt; &quot;name&quot; , &quot;type&quot; =&gt; &quot;string&quot; } , %{ &quot;name&quot; =&gt; &quot;wallet&quot; , &quot;type&quot; =&gt; &quot;address&quot; } , ] , &quot;Mail&quot; =&gt; [ %{ &quot;name&quot; =&gt; &quot;from&quot; , &quot;type&quot; =&gt; &quot;Person&quot; } , %{ &quot;name&quot; =&gt; &quot;to&quot; , &quot;type&quot; =&gt; &quot;Person&quot; } , %{ &quot;name&quot; =&gt; &quot;contents&quot; , &quot;type&quot; =&gt; &quot;string&quot; } , ] } , &quot;value&quot; =&gt; %{ &quot;from&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Cow&quot; , &quot;wallet&quot; =&gt; &quot;0xCD2A3D9F938E13CD947EC05ABC7FE734DF8DD826&quot; } , &quot;to&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Bob&quot; , &quot;wallet&quot; =&gt; &quot;0xBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB&quot; } , &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; } }","ref":"Signet.Typed.html#serialize/1","title":"Signet.Typed.serialize/1","type":"function"},{"doc":"","ref":"Signet.Typed.html#t:t/0","title":"Signet.Typed.t/0","type":"type"},{"doc":"","ref":"Signet.Typed.html#t:type_map/0","title":"Signet.Typed.type_map/0","type":"type"},{"doc":"","ref":"Signet.Typed.html#t:value_map/0","title":"Signet.Typed.value_map/0","type":"type"},{"doc":"","ref":"Signet.Typed.Domain.html","title":"Signet.Typed.Domain","type":"module"},{"doc":"Deserializes a domain from JSON or JavaScript encoding to a struct. Examples iex&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Ether Mail&quot; , ...&gt; &quot;version&quot; =&gt; &quot;1&quot; , ...&gt; &quot;chainId&quot; =&gt; 1 , ...&gt; &quot;verifyingContract&quot; =&gt; &quot;0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC&quot; , ...&gt; } ...&gt; |&gt; Signet.Typed.Domain . deserialize ( ) % Signet.Typed.Domain { name : &quot;Ether Mail&quot; , version : &quot;1&quot; , chain_id : 1 , verifying_contract : &lt;&lt; 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 &gt;&gt; }","ref":"Signet.Typed.Domain.html#deserialize/1","title":"Signet.Typed.Domain.deserialize/1","type":"function"},{"doc":"","ref":"Signet.Typed.Domain.html#domain_type/0","title":"Signet.Typed.Domain.domain_type/0","type":"function"},{"doc":"Serializes a domain, such that it can be JSON-encoded or passed to JavaScript. Examples iex&gt; % Signet.Typed.Domain { ...&gt; name : &quot;Ether Mail&quot; , ...&gt; version : &quot;1&quot; , ...&gt; chain_id : 1 , ...&gt; verifying_contract : &lt;&lt; 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 &gt;&gt; ...&gt; } ...&gt; |&gt; Signet.Typed.Domain . serialize ( ) %{ &quot;name&quot; =&gt; &quot;Ether Mail&quot; , &quot;version&quot; =&gt; &quot;1&quot; , &quot;chainId&quot; =&gt; 1 , &quot;verifyingContract&quot; =&gt; &quot;0xCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC&quot; , }","ref":"Signet.Typed.Domain.html#serialize/1","title":"Signet.Typed.Domain.serialize/1","type":"function"},{"doc":"Serializes a domain's keys to be JSON-compatible. This is so that it can be used as a value for hashStruct , per the EIP-712 spec to build a domain specifier. Examples iex&gt; % Signet.Typed.Domain { ...&gt; name : &quot;Ether Mail&quot; , ...&gt; version : &quot;1&quot; , ...&gt; chain_id : 1 , ...&gt; verifying_contract : &lt;&lt; 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 &gt;&gt; ...&gt; } ...&gt; |&gt; Signet.Typed.Domain . serialize_keys ( ) %{ &quot;name&quot; =&gt; &quot;Ether Mail&quot; , &quot;version&quot; =&gt; &quot;1&quot; , &quot;chainId&quot; =&gt; 1 , &quot;verifyingContract&quot; =&gt; &lt;&lt; 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 , 204 &gt;&gt; }","ref":"Signet.Typed.Domain.html#serialize_keys/1","title":"Signet.Typed.Domain.serialize_keys/1","type":"function"},{"doc":"","ref":"Signet.Typed.Domain.html#t:t/0","title":"Signet.Typed.Domain.t/0","type":"type"},{"doc":"","ref":"Signet.Typed.Type.html","title":"Signet.Typed.Type","type":"module"},{"doc":"Deserializes a Type from JSON or a map into a struct. Examples iex&gt; [ %{ ...&gt; &quot;name&quot; =&gt; &quot;from&quot; , ...&gt; &quot;type&quot; =&gt; &quot;Person&quot; , ...&gt; } , %{ ...&gt; &quot;name&quot; =&gt; &quot;to&quot; , ...&gt; &quot;type&quot; =&gt; &quot;Person&quot; , ...&gt; } , %{ ...&gt; &quot;name&quot; =&gt; &quot;contents&quot; , ...&gt; &quot;type&quot; =&gt; &quot;string&quot; , ...&gt; } ] ...&gt; |&gt; Signet.Typed.Type . deserialize ( ) % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] }","ref":"Signet.Typed.Type.html#deserialize/1","title":"Signet.Typed.Type.deserialize/1","type":"function"},{"doc":"Deserializes a primitive or custom type. We differentiate custom types by not being a primitive type. Examples iex&gt; Signet.Typed.Type . deserialize_type ( &quot;address&quot; ) :address iex&gt; Signet.Typed.Type . deserialize_type ( &quot;uint256&quot; ) { :uint , 256 } iex&gt; Signet.Typed.Type . deserialize_type ( &quot;bytes32&quot; ) { :bytes , 32 } iex&gt; Signet.Typed.Type . deserialize_type ( &quot;Person&quot; ) &quot;Person&quot;","ref":"Signet.Typed.Type.html#deserialize_type/1","title":"Signet.Typed.Type.deserialize_type/1","type":"function"},{"doc":"Deserializes a value of a given type for being stored in this struct. Examples iex&gt; Signet.Typed.Type . deserialize_value! ( &quot;0x0000000000000000000000000000000000000001&quot; , :address ) &lt;&lt; 1 :: 160 &gt;&gt; iex&gt; Signet.Typed.Type . deserialize_value! ( 55 , { :uint , 256 } ) 55 iex&gt; Signet.Typed.Type . deserialize_value! ( &quot;0x00000000000000000000000000000000000000000000000000000000000000CC&quot; , { :bytes , 32 } ) &lt;&lt; 0xCC :: 256 &gt;&gt; iex&gt; Signet.Typed.Type . deserialize_value! ( &quot;0xCC&quot; , { :bytes , 32 } ) &lt;&lt; 0xCC :: 256 &gt;&gt; iex&gt; Signet.Typed.Type . deserialize_value! ( &quot;Cow&quot; , :string ) &quot;Cow&quot;","ref":"Signet.Typed.Type.html#deserialize_value!/2","title":"Signet.Typed.Type.deserialize_value!/2","type":"function"},{"doc":"Encodes a value for encodeData , as per the EIP-712 spec. Specifically, raw values are expanded to 32-bytes, and dynamic types are hashed. Examples iex&gt; Signet.Typed.Type . encode_data_value ( &lt;&lt; 1 :: 160 &gt;&gt; , :address ) &lt;&lt; 1 :: 256 &gt;&gt; iex&gt; Signet.Typed.Type . encode_data_value ( 55 , { :uint , 256 } ) &lt;&lt; 0 :: 248 , 55 &gt;&gt; iex&gt; Signet.Typed.Type . encode_data_value ( &lt;&lt; 0xCC &gt;&gt; , { :bytes , 32 } ) &lt;&lt; 0 :: 248 , 0xCC &gt;&gt;","ref":"Signet.Typed.Type.html#encode_data_value/2","title":"Signet.Typed.Type.encode_data_value/2","type":"function"},{"doc":"Serializes a Type, such that it can be used with JSON or JavaScript. Examples iex&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } ...&gt; |&gt; Signet.Typed.Type . serialize ( ) [ %{ &quot;name&quot; =&gt; &quot;from&quot; , &quot;type&quot; =&gt; &quot;Person&quot; , } , %{ &quot;name&quot; =&gt; &quot;to&quot; , &quot;type&quot; =&gt; &quot;Person&quot; , } , %{ &quot;name&quot; =&gt; &quot;contents&quot; , &quot;type&quot; =&gt; &quot;string&quot; , } ]","ref":"Signet.Typed.Type.html#serialize/1","title":"Signet.Typed.Type.serialize/1","type":"function"},{"doc":"Serializes a primitive or custom type. Examples iex&gt; Signet.Typed.Type . serialize_type ( :address ) &quot;address&quot; iex&gt; Signet.Typed.Type . serialize_type ( { :uint , 256 } ) &quot;uint256&quot; iex&gt; Signet.Typed.Type . serialize_type ( { :bytes , 32 } ) &quot;bytes32&quot; iex&gt; Signet.Typed.Type . serialize_type ( &quot;Person&quot; ) &quot;Person&quot;","ref":"Signet.Typed.Type.html#serialize_type/1","title":"Signet.Typed.Type.serialize_type/1","type":"function"},{"doc":"Serializes a value of a given type to pass to JSON or JavaScript. Examples iex&gt; Signet.Typed.Type . serialize_value ( &lt;&lt; 1 :: 160 &gt;&gt; , :address ) &quot;0x0000000000000000000000000000000000000001&quot; iex&gt; Signet.Typed.Type . serialize_value ( 55 , { :uint , 256 } ) 55 iex&gt; Signet.Typed.Type . serialize_value ( &lt;&lt; 0xCC :: 256 &gt;&gt; , { :bytes , 32 } ) &quot;0x00000000000000000000000000000000000000000000000000000000000000CC&quot; iex&gt; Signet.Typed.Type . serialize_value ( &lt;&lt; 0xCC &gt;&gt; , { :bytes , 32 } ) &quot;0x00000000000000000000000000000000000000000000000000000000000000CC&quot; iex&gt; Signet.Typed.Type . serialize_value ( &quot;Cow&quot; , :string ) &quot;Cow&quot;","ref":"Signet.Typed.Type.html#serialize_value/2","title":"Signet.Typed.Type.serialize_value/2","type":"function"},{"doc":"","ref":"Signet.Typed.Type.html#t:field_type/0","title":"Signet.Typed.Type.field_type/0","type":"type"},{"doc":"","ref":"Signet.Typed.Type.html#t:primitive/0","title":"Signet.Typed.Type.primitive/0","type":"type"},{"doc":"","ref":"Signet.Typed.Type.html#t:t/0","title":"Signet.Typed.Type.t/0","type":"type"},{"doc":"","ref":"Signet.Typed.Type.html#t:type_list/0","title":"Signet.Typed.Type.type_list/0","type":"type"},{"doc":"","ref":"Signet.Util.html","title":"Signet.Util","type":"module"},{"doc":"","ref":"Signet.Util.html#decode_hex!/1","title":"Signet.Util.decode_hex!/1","type":"function"},{"doc":"Decodes a hex string, specifically requiring that the string begins with 0x and allows mixed-case typing. Examples iex&gt; Signet.Util.decode_hex(&quot;0x1122&quot;) iex&gt; Signet.Util.decode_hex(&quot;0x1&quot;) iex&gt; Signet.Util.decode_hex(&quot;0xGG&quot;) :error","ref":"Signet.Util.html#decode_hex/1","title":"Signet.Util.decode_hex/1","type":"function"},{"doc":"Decodes hex, allowing it to either by &quot;0x...&quot; or &lt;&lt;1::160&gt;&gt;. Note: a hex-printed string, in this case, must start with 0x, otherwise it will be interpreted as its ASCII values . Examples iex&gt; Signet.Util . decode_hex_input! ( &quot;0x55&quot; ) &lt;&lt; 0x55 &gt;&gt; iex&gt; Signet.Util . decode_hex_input! ( &lt;&lt; 0x55 &gt;&gt; ) &lt;&lt; 0x55 &gt;&gt;","ref":"Signet.Util.html#decode_hex_input!/1","title":"Signet.Util.decode_hex_input!/1","type":"function"},{"doc":"Encodes a number as a binary representation of a certain number of bytes. Examples iex&gt; Signet.Util.encode_bytes(257, 4) &lt;&lt;0, 0, 1, 1&gt;&gt; iex&gt; Signet.Util.encode_bytes(nil, 4) nil","ref":"Signet.Util.html#encode_bytes/2","title":"Signet.Util.encode_bytes/2","type":"function"},{"doc":"Encodes a hex string, adding a 0x prefix. Note: if short is set, then any leading zeros will be stripped. Examples iex&gt; Signet.Util.encode_hex(&lt;&lt;0x11, 0x22&gt;&gt;) &quot;0x1122&quot; iex&gt; Signet.Util.encode_hex(&lt;&lt;0xc&gt;&gt;) &quot;0x0C&quot; iex&gt; Signet.Util.encode_hex(&lt;&lt;0xc&gt;&gt;, true) &quot;0xC&quot; iex&gt; Signet.Util.encode_hex(&lt;&lt;0x0&gt;&gt;, true) &quot;0x0&quot;","ref":"Signet.Util.html#encode_hex/2","title":"Signet.Util.encode_hex/2","type":"function"},{"doc":"Returns an Ethereum address from a given DER-encoded public key. Examples iex&gt; public_key = Signet.Util.decode_hex!(&quot;0x0422&quot;) iex&gt; Signet.Util.get_eth_address(public_key) |&gt; Signet.Util.encode_hex() &quot;0x759F1AFDC24ABA433A3E18B683F8C04A6EAA69F0&quot;","ref":"Signet.Util.html#get_eth_address/1","title":"Signet.Util.get_eth_address/1","type":"function"},{"doc":"See Signet.Hash.keccak/1 .","ref":"Signet.Util.html#keccak/1","title":"Signet.Util.keccak/1","type":"function"},{"doc":"Pads a binary to a given length Examples iex&gt; Signet.Util.pad(&lt;&lt;1, 2&gt;&gt;, 2) &lt;&lt;1, 2&gt;&gt; iex&gt; Signet.Util.pad(&lt;&lt;1, 2&gt;&gt;, 4) &lt;&lt;0, 0, 1, 2&gt;&gt; iex&gt; Signet.Util.pad(&lt;&lt;1, 2&gt;&gt;, 1) ** (FunctionClauseError) no function clause matching in Signet.Util.pad/2","ref":"Signet.Util.html#pad/2","title":"Signet.Util.pad/2","type":"function"},{"doc":"Parses a chain id, which can be given as an integer or an atom of a known network. Examples iex&gt; Signet.Util . parse_chain_id ( 5 ) 5 iex&gt; Signet.Util . parse_chain_id ( :goerli ) 5","ref":"Signet.Util.html#parse_chain_id/1","title":"Signet.Util.parse_chain_id/1","type":"function"},{"doc":"Converts a number to wei, possibly from gwei, etc. Examples iex&gt; Signet.Util . to_wei ( 100 ) 100 iex&gt; Signet.Util . to_wei ( { 100 , :gwei } ) 100000000000","ref":"Signet.Util.html#to_wei/1","title":"Signet.Util.to_wei/1","type":"function"},{"doc":"Signet is a lightweight Ethereum RPC client for Elixir. The goal is to make it easy to interact with Ethereum in Elixir. As an example: { :ok , trx_id } = Signet.RPC . execute_trx ( &quot;0x123...&quot; , { &quot;transfer(uint)&quot; , [ 50 ] } , gas_price : { 50 , :gwei } , value : 0 ) The above code will use a signer you set-up (see below) to send a build, sign and transmit a transaction to Infura. Signet handles determining your nonce and estimating the gas cost, and, by default, fails if the transaction were to revert. Signet has a number of other features, including: Signing and verifying Ethereum signatures (including EIP-191 ) Signing and verifying EIP-712 typed data Signing via Curvy or Google KMS . Note: Curvy signatures should be avoided in production. Filters through active processes","ref":"readme.html","title":"Signet 🪧","type":"extras"},{"doc":"Signet can be installed by adding signet to your list of dependencies in mix.exs : def deps do [ { :signet , &quot;~&gt; 0.1.0-rc1&quot; } ] end Documentation can be found at https://hexdocs.pm/signet .","ref":"readme.html#installation","title":"Signet 🪧 - Installation","type":"extras"},{"doc":"Signers First, you'll need to set-up a signer, which will be used to sign transactions or other messages. Signers are GenServers, and uou can set-up several signers, and you will specify a name of a signer (or pid) at the point of actually using the signer. Currently there are two supported signers: raw keys or Google KMS. Raw Key Note: This uses an experimental Elixir signing library, Curvy, and is considered unsafe for production. You can specify a signer key by configuring: runtime.exs config :signet , :signers , %{ MySigner : { :priv_key , System . get_env ( &quot;MY_PRIVATE_KEY&quot; ) } } Then use MySigner when asked for a signer when using Signet. You can also specify a default signer, which will be used by default so you do not need to specify the signer in your calls: config :signet , :signer , { :priv_key , System . get_env ( &quot;MY_PRIVATE_KEY&quot; ) } Google KMS You can set-up Google KMS by configuring: config :signet , :signers , %{ MySigner : { :cloud_kms , GCPCredentials , &quot;projects/{project}/locations/{location}/keyRings/{keyring}/cryptoKeys/{keyid}&quot; , &quot;1&quot; } } This will use your given key from the URL, version &quot;1&quot;, for signing. GCPCredentials should be a Goth process set-up with proper credentials to access Google Cloud KMS. Custom Signers You can also specify custom signers by specifying an mfa that implements the required behavior: config :signet , :signers , %{ MySigner : { :mfa , Signet.Signer.Curvy , :sign , [ &lt;&lt; 1 :: 256 &gt;&gt; ] } } Feel free to add pull requests with new signing methods. You can also spawn your own process by adding to your start-up application: children = [ # ... { Signet.Signer , mfa : { ... } , chain_id : chain_id , name : MySigner } ] Note: if you do not name your signer, it will be named Signet.Signer.Default and will be used to sign all transactions unless otherwise specified. Signing Now that you have a signer, you can sign data, for instance: { :ok , sig } = Signet.Signer . sign ( &quot;test&quot; , MySigner ) And then you can recover it via: signer_address = Signet.Recover . recover_eth ( &quot;test&quot; , sig ) You can also sign EIP-712 typed data: % Signet.Typed { domain : % Signet.Typed.Domain { chain_id : 1 , name : &quot;Ether Mail&quot; , verifying_contract : Signet.Util . decode_hex! ( &quot;0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC&quot; ) , version : &quot;1&quot; } , types : %{ &quot;Mail&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;from&quot; , &quot;Person&quot; } , { &quot;to&quot; , &quot;Person&quot; } , { &quot;contents&quot; , :string } ] } , &quot;Person&quot; =&gt; % Signet.Typed.Type { fields : [ { &quot;name&quot; , :string } , { &quot;wallet&quot; , :address } ] } } , value : %{ &quot;contents&quot; =&gt; &quot;Hello, Bob!&quot; , &quot;from&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Cow&quot; , &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826&quot; ) } , &quot;to&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Bob&quot; , &quot;wallet&quot; =&gt; Signet.Util . decode_hex! ( &quot;0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB&quot; ) } } } |&gt; Signet.Typed . encode ( ) |&gt; Signet.Signer . sign ( ) RPC Signet includes an RPC library to talk to Ethereum nodes, such as Infura. First, specify an Ethereum node address, e.g. config.exs config :signet , :rpc , ethereum_node : &quot;https://goerli.infura.io&quot; chain_id : :goerli Then, you can run any Ethereum JSON-RPC command, e.g.: Signet.RPC . send_rpc ( &quot;net_version&quot; , [ ] ) { :ok , &quot;3&quot; } You can build an Ethereum (pre-EIP-1559) transaction, e.g.: transaction = Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 1 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) And you can get the results from calling that transaction, via: { :ok , &lt;&lt; 0x0c &gt;&gt; } = Signet.RPC . call_trx ( transaction ) And if you're happy, you can send the trx: { :ok , trx_id } = Signet.RPC . send_trx ( transaction ) You can also pass in known Solidity errors, to have them decoded for you, e.g.: &gt; errors = [ &quot;Cool(uint256,string)&quot; ] &gt; Signet.Transaction.V1 . new ( 1 , { 100 , :gwei } , 100_000 , &lt;&lt; 11 :: 160 &gt;&gt; , { 2 , :wei } , &lt;&lt; 1 , 2 , 3 &gt;&gt; ) &gt; |&gt; Signet.RPC . call_trx ( errors : errors ) { :error , &quot;error 3: execution reverted (Cool(uint256,string)[1, \\&quot; cat \\&quot; ])&quot; } Finally, execute_trx is similar to sending transactions with Web3, which will pull a nonce and estimate gas, before submitting the transaction to the Ethereum node: { :ok , trx_id } = Signet.RPC . execute_trx ( &lt;&lt; 1 :: 160 &gt;&gt; , { &quot;baz(uint,address)&quot; , [ 50 , &lt;&lt; 1 :: 160 &gt;&gt; |&gt; :binary . decode_unsigned ] } , gas_price : { 50 , :gwei } , gas_limit : 100_000 , value : 0 , nonce : 10 ) Note: due to our ABI encoder, addresses should be passed in as unsigned s, not binaries. Filtering The library also has a built-in system to use JSON-RPC filters (i.e. via eth_newFilter ). In your application.ex (or any other supervisor), start a new filter: children = [ # ... # Filter name # Address # Topics { Signet.Filter , [ MyTransferFilter , &lt;&lt; 1 :: 160 &gt;&gt; , [ &lt;&lt; 2 :: 256 &gt;&gt; ] ] } ] Then, in your code, any process can register to hear events from the filter via: Signet.Filter . listen ( MyTransferFilter ) Once registered, events will be passed in via Elixir messages {:event, event} for decoded events and {:log, log} for plain logs. For example: defmodule MyGenServer do use GenServer # ... def init ( _ ) do Signet.Filter . listen ( MyTransferFilter ) end def handle_info ( { :event , event } , state ) do IO . inspect ( event , label : &quot;New Event&quot; ) { :noreply , state } end def handle_info ( { :log , log } , state ) do IO . inspect ( log , label : &quot;New Log&quot; ) { :noreply , state } end end Currently, only ERC-20 transfer events as decoded, e.g. as: { :event , { &quot;Transfer&quot; , %{ from : &lt;&lt; 1 :: 160 &gt;&gt; , to : &lt;&lt; 2 :: 160 &gt;&gt; , amount : 100 } } } Note: filters may expire if not refreshed every so often. The filter code does not attempt to reach back in time if a filter is expired- that is up to your code.","ref":"readme.html#getting-started","title":"Signet 🪧 - Getting Started","type":"extras"},{"doc":"Create a PR to contribute to Signet. All contributors agree to accept the license specified in this repository for all contributions to this project. See LICENSE.md . Feel free to create Feature Requests in the issues.","ref":"readme.html#contributing","title":"Signet 🪧 - Contributing","type":"extras"}]